#include "Animal.h"
#include "string.h" // strncpy()
#include <conio.h> // gotoxy()
#include <iostream.h> // cout
#include <stdlib.h> // rand()

Animal::Animal(const char *symbol, int initX, int initY, 
               int maxTimeToSleep, int stepSize,
               int maxNumberOfWatchedRacers, int aheadSteps):
    m_xPos(initX), m_yPos(initY),
    m_maxNumberOfWatchedRacers(maxNumberOfWatchedRacers),
    m_numberOfWatchedRacers(0),
    m_watchedRacers(new Animal *[maxNumberOfWatchedRacers]),
    m_stepSize(stepSize),
    m_timeToSleep(0),
    m_aheadSteps(aheadSteps),
    m_maxTimeToSleep(maxTimeToSleep<5 ? 5 : maxTimeToSleep)
{
    strncpy(m_symbol, symbol, 2);
    m_symbol[2] = 0;
    draw();
}

Animal::~Animal()
{
    delete[] m_watchedRacers;
}

void Animal::draw() const
{
    gotoxy(m_xPos-1, m_yPos);
    cout << m_symbol;
}

void Animal::erase() const
{
    int i;
    gotoxy(m_xPos-1, m_yPos);
    for (i=0; i<strlen(m_symbol); i++)
        cout << ' ';
}

BOOL Animal::addToWatchList(const Animal & toWatch)
{
    if (m_numberOfWatchedRacers < m_maxNumberOfWatchedRacers)
    {
        m_watchedRacers[m_numberOfWatchedRacers++] = &toWatch;
        return TRUE;
    }
    else
        return FALSE;
}

int Animal::numberOfWatchedRacers() const
{
    return m_numberOfWatchedRacers;
}

BOOL Animal::getTo(int position) const
{
    if (m_xPos >= position)
        return TRUE;
    else
        return FALSE;
}

void Animal::runOneStep()
{
    if (m_timeToSleep > 0)
        m_timeToSleep--;
    else
    {
        if (isTimeToTakeARest())
            m_timeToSleep = rand() % (m_maxTimeToSleep-5) + 5;
        else
        {
            erase();
            m_xPos += m_stepSize;
            draw();
        }
    }
}

void Animal::moveTo(int x, int y)
{
    erase();
    m_xPos = x;
    m_yPos = y;
    draw();
}

BOOL Animal::isTimeToTakeARest() const
{
    if (m_numberOfWatchedRacers == 0) 
        return FALSE;

    int i;
    for (i=0; i<m_numberOfWatchedRacers; i++)
        if (m_watchedRacers[i]->getTo(m_xPos-m_aheadSteps))
            return FALSE;
    return TRUE;
}




